/***********************************************************
Yahoo
***********************************************************/
function initHandler5(handler){
  handler.initStage=ST_PRE;
  handler.inboxOnly=handler.webMailNotifier.prefBranch.getBoolPref("webmail5.inboxOnly");
  var ar=handler.user.split("@");
  if(ar[1]=="yahoo.co.jp"){
    handler.dataURL="http://mail.yahoo.co.jp/"
    handler.loginData=["https://login.yahoo.co.jp/config/login?",
                        "","passwd","login="+encodeURIComponent(ar[0])];
    handler.mailURL="http://mail.yahoo.co.jp/"
  }else{
    handler.dataURL="http://mail.yahoo.com/"
    handler.loginData=["https://login.yahoo.com/config/login?",
                        "login","passwd",""];
    handler.mailURL="http://mail.yahoo.com/"
  }
  handler.process=function (aHttpChannel, aData) {
    switch(this.stage){
    case ST_PRE:
      this.webMailNotifier.getHtml(this,this.dataURL);
      return false;
    case ST_PRE_RES:
      this.stage=ST_LOGIN;
      break;
    case ST_LOGIN_RES:
      var fnd=this.data.match(/<input.+?type="hidden".+?name=".secdata".+?value="(.+?)".*?>/);
      if(fnd){
        if(this.webMailNotifier.listeners.length>0){
          var rs=this.webMailNotifier.listeners[0].openYahooDialog(this.user,fnd[1]);
          if(rs){
            this.webMailNotifier.getHtml(this,this.loginData[LOGIN_URL],this.loginData[LOGIN_POST]+"&.secdata="+encodeURIComponent(fnd[1])+"&.secword="+encodeURIComponent(rs));
            return false;
          }
        }
        this.stage=this.initStage;
        this.webMailNotifier.setState(this.id,this.user,nsIWebMailNotifier.ST_RESET);
        return true;
      }
      this.stage=ST_DATA;
      break;
    case (ST_LOGIN_RES+1):
      this.stage=ST_DATA;
      break;
    case (ST_DATA_RES):
      var fnd=aData.match(/doAction\(\'2\',\s*?\'(\S+?)\'/);
      if(fnd){//not supported os
        try{
          var location=aHttpChannel.getResponseHeader("Location");
          location=location.match(/\S+yahoo.com/);
          this.webMailNotifier.getHtml(this,location+"/dc/system_requirements.php","a=2&crumb="+encodeURIComponent(fnd[1]));
          return false;
        }catch(e){}
      }
      break;
    case (ST_DATA_RES+1):
      this.stage=ST_DATA;
      break;
    }
    return WebMailHandler.prototype.process.call(this,aHttpChannel, aData);
  };
  handler.onRequest=function(aHttpChannel){
    WebMailHandler.prototype.onRequest.call(this,aHttpChannel);
    if(this.stage==this.initStage){
      try{
        var s=this.webMailNotifier.prefBranch.getCharPref("webmail"+this.id+"."+this.user+".cookie");
        s=s.split("\t");
        var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                        .getService(Components.interfaces.nsIIOService);
        var uri=ioService.newURI(s[0],null,null);
        this.cookieManager.addCookies(uri,s[1]);
      }catch(e){}
    }
  };
  handler.onResponse=function(aHttpChannel){
    WebMailHandler.prototype.onResponse.call(this,aHttpChannel);
    if(this.stage==(ST_LOGIN_RES+1)){
      var s=this.cookieManager.findCookie(aHttpChannel.URI.spec,"F");
      if(s){
        this.webMailNotifier.prefBranch.setCharPref("webmail"+this.id+"."+this.user+".cookie",aHttpChannel.URI.spec+"\t"+s);
      }
    }
  };
  handler.getData=function(aData){
    var fnd=aData.match(/<div.+?folderlist.+?>([\s\S]+?)<div class=\"last\">/);
    if(fnd){//original mode
      fnd=fnd[1];
      if(!this.inboxOnly){
        var fnd2=aData.match(/<div.+?customfolders.+?>([\s\S]+?)<div class=\"last\">/);
        if(fnd2){
          fnd+=fnd2[1];
        }
      }
      fnd=fnd.match(/<li .+?<\/a>/g);
      if(fnd){
        var s;
        var num=0;
        for each(s in fnd){
          var t=s.match(/li\s+id=\"(.+?)\"/);
          if(t){
            if(t[1]=="draft"||t[1]=="sent"
              ||t[1]=="bulk"||t[1]=="trash")continue;
          }
          s=s.match(/<a.+?>.+?\((\d+)\).*?<\/a>/);
          if(s)num+=parseInt(s[1]);
          if(this.inboxOnly&&t[1]=="inbox")break;
        }
        return num;
      }
    }else{
      fnd=aData.match(/<ListFoldersResponse>([\s\S]+?)<\/ListFoldersResponse>/);
      if(fnd){
        fnd=fnd[1].match(/<folder.+?<\/folder>/g);
        if(fnd){
          var s;
          var num=0;
          for each(s in fnd){
            s=s.match(/unread=\\?\"(\d+)\\?\".+?fid=\\?\"(.+?)\\?\"/);
            if(s){
              if(s[2]=="%40B%40Bulk"||s[2]=="Draft"
                ||s[2]=="Sent"||s[2]=="Trash")continue;
              num+=parseInt(s[1]);
              if(this.inboxOnly&&s[2]=="Inbox")break;
            }
          }
          return num;
        }
      }
    }
    return -1;
  };
}
